import { PlusOutlined } from '@ant-design/icons';
import type { ActionType, ProColumns } from '@ant-design/pro-components';
import { message, Popconfirm } from 'antd';
import React, { useCallback, useRef, useState } from 'react';
import ConfigurableDrawerForm, {
  type ConfigurableDrawerFormRef,
} from '@/components/DrawerForm';
import EnhancedProTable from '@/components/EnhancedProTable';
import type { ToolbarAction } from '@/components/EnhancedProTable/types';
import { formStatusType } from '@/constants';
import {
  type AiModelRespVO,
  createModel,
  delModel,
  getModelList,
  updateModel,
  updateModelStatus,
} from '@/services/ai/model';
import { baseDeptColumns, formColumns } from './config';

const ModelPage = () => {
  const configurableDrawerRef = useRef<ConfigurableDrawerFormRef>(null);
  const tableRef = useRef<ActionType>(null);

  const [type, setType] = useState<'create' | 'update'>('create');
  const [id, setId] = useState<number>(0);

  const handleEdit = (record: AiModelRespVO) => {
    setType('update');
    setId(record.id as number);
    configurableDrawerRef.current?.open(record);
  };

  const onFetch = async (params: { pageSize?: number; current?: number }) => {
    const data = await getModelList({ ...params, pageNo: params.current });
    return {
      data: data.list,
      success: true,
      total: data.total,
    };
  };

  const handleAdd = () => {
    setType('create');
    configurableDrawerRef.current?.open({ status: true });
  };

  const handleSubmit = useCallback(
    async (values: AiModelRespVO) => {
      if (type === 'create') {
        console.log('values', values);
        await createModel({ ...values, status: values.status ? 1 : 0 });
      } else {
        await updateModel({
          ...values,
          status: values.status ? 1 : 0,
          id,
        });
      }
      tableRef.current?.reload();
      return true;
    },
    [type, id],
  );

  const toolbarActions: ToolbarAction[] = [
    {
      key: 'add',
      label: '新建',
      type: 'primary',
      icon: <PlusOutlined />,
      onClick: handleAdd,
    },
  ];

  const actionColumns: ProColumns<AiModelRespVO> = {
    title: '操作',
    dataIndex: 'option',
    valueType: 'option',
    fixed: 'right',
    width: 120,
    render: (
      _text: React.ReactNode,
      record: AiModelRespVO,
      _: any,
      action: any,
    ) => [
      <a key="editable" onClick={() => handleEdit(record)}>
        编辑
      </a>,
      <Popconfirm
        title="是否删除?"
        key="delete"
        onConfirm={async () => {
          await delModel(record.id as number);
          message.success('删除成功');
          action?.reload();
        }}
        okText="是"
        cancelText="否"
      >
        <a>删除</a>
      </Popconfirm>,
    ],
  };

  const columns = [...baseDeptColumns, actionColumns];
  return (
    <>
      <EnhancedProTable<AiModelRespVO>
        ref={tableRef}
        columns={columns}
        request={onFetch}
        toolbarActions={toolbarActions}
        headerTitle="模型管理"
        showIndex={false}
        showSelection={false}
        search={false}
      />

      <ConfigurableDrawerForm
        ref={configurableDrawerRef}
        title={formStatusType[type]}
        columns={formColumns(type)}
        onSubmit={handleSubmit}
      />
    </>
  );
};

export default ModelPage;
